#include "Gauge.h"

const double GAUGE_HEIGHT    = 32.0;
const double GAUGE_HEIGHT_UV = 32.0/256.0;

// RXgN^
Gauge::Gauge(void)
{
	gaugeModel.readPNG("gauge.png");	// 摜ǂݍ
	// ǂݍ񂾉摜MeshTextureɗp
	gaugeShape.setImage(gaugeModel.getImage());
	// MeshTexture\`Ƃčւ
	gaugeModel.setShape(&gaugeShape);

	// 摜̕Ƃ肠Q[WTCYƂ(ӂ͏ɉĕς邱)
	lenNow = lenMax = (double)gaugeModel.getImage()->getWidth();

	MakeBase();				// yĂяo
	setValueDirect(lenNow);	// őlŃQ[WZbg

	return;
}

// fXgN^
Gauge::~Gauge(void)
{
	// Ƃ肠邱ƂȂ
}

void Gauge::entryWindow(fkut_SimpleWindow &argWin)
{
	argWin.entry(gaugeModel);
	return;
}

void Gauge::MakeBase(void)
{
	/*
	setVertexPos()ŁAʏ̂ǂ̈ʒuɕ\邩߂B
	MeshTexture͎Op`x[Xŏ̂ŁA1̃Q[W2Op`gB
	gwiƂāAOp`ID 0,1 ō쐬B
	̍W(0,0)ƂāA

	(0,0)							(Q[W,0)
	_________________________________
	|								|
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	(0,-Q[W)					(Q[W,-Q[W)

	ƂBOp`IDƊe_̑Ή(Op`,_)́A

	(0,0)&(1,0)						(1,2)
	_________________________________
	|								|
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	(0,1)							(0,2)&(1,1)

	ƂB
	*/
	gaugeShape.setVertexPos(0, 0,    0.0,           0.0, 0.0);
	gaugeShape.setVertexPos(0, 1,    0.0, -GAUGE_HEIGHT, 0.0);
	gaugeShape.setVertexPos(0, 2, lenMax, -GAUGE_HEIGHT, 0.0);
	gaugeShape.setVertexPos(1, 0,    0.0,           0.0, 0.0);
	gaugeShape.setVertexPos(1, 1, lenMax, -GAUGE_HEIGHT, 0.0);
	gaugeShape.setVertexPos(1, 2, lenMax,           0.0, 0.0);

	/*
	setTextureCoord()ŁA摜̂ǂ̕؂oĕ\邩߂B
	eNX`ẂA摜̃TCYɂ炸A

	(0,1)	(1,1)
	_________
	|		|
	|		|
	|		|
	|		|
	~~~~~~~~~
	(0,0)	(1.0)

	ƂȂ̂ŁAhbgPʂŐ؂oʒuw肷ꍇ́A
	uw肵hbg / ⍂̃hbgv̒lpB
	̕ɂӂ邱ƁB
	*/
	gaugeShape.setTextureCoord(0, 0, 0.0, 1.0-GAUGE_HEIGHT_UV*3.0);
	gaugeShape.setTextureCoord(0, 1, 0.0, 1.0-GAUGE_HEIGHT_UV*4.0);
	gaugeShape.setTextureCoord(0, 2, 1.0, 1.0-GAUGE_HEIGHT_UV*4.0);
	gaugeShape.setTextureCoord(1, 0, 0.0, 1.0-GAUGE_HEIGHT_UV*3.0);
	gaugeShape.setTextureCoord(1, 1, 1.0, 1.0-GAUGE_HEIGHT_UV*4.0);
	gaugeShape.setTextureCoord(1, 2, 1.0, 1.0-GAUGE_HEIGHT_UV*3.0);

	return;
}

void Gauge::setValueDirect(double argValue, int argLV)
{
	lenNow = argValue;
	double texU = lenNow/lenMax;

	gaugeShape.setVertexPos(2, 0,    0.0,   0.0, 0.0);
	gaugeShape.setVertexPos(2, 1,    0.0, -GAUGE_HEIGHT, 0.0);
	gaugeShape.setVertexPos(2, 2, lenNow, -GAUGE_HEIGHT, 0.0);
	gaugeShape.setVertexPos(3, 0,    0.0,   0.0, 0.0);
	gaugeShape.setVertexPos(3, 1, lenNow, -GAUGE_HEIGHT, 0.0);
	gaugeShape.setVertexPos(3, 2, lenNow,   0.0, 0.0);
	/*
	lɂĐFςꍇ̎ƂāA
	l(0`2)ɂăJ[Oς悤ɂĂB
	main()ŐFwĂ̂ŁAQƂ邱ƁB
	lɂĐ؂oʒuς悤ɂƁA_ȃvOɂȂB
	*/
	gaugeShape.setTextureCoord(2, 0,  0.0, 1.0-GAUGE_HEIGHT_UV*double(argLV));
	gaugeShape.setTextureCoord(2, 1,  0.0, 1.0-GAUGE_HEIGHT_UV*double(argLV+1));
	gaugeShape.setTextureCoord(2, 2, texU, 1.0-GAUGE_HEIGHT_UV*double(argLV+1));
	gaugeShape.setTextureCoord(3, 0,  0.0, 1.0-GAUGE_HEIGHT_UV*double(argLV));
	gaugeShape.setTextureCoord(3, 1, texU, 1.0-GAUGE_HEIGHT_UV*double(argLV+1));
	gaugeShape.setTextureCoord(3, 2, texU, 1.0-GAUGE_HEIGHT_UV*double(argLV));

	return;
}
